GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})

PrefabFiles = { 
	"skd",  
--	"skd_none", 
	"skd_sword",
	"skd_hat",
	"skd_ycbg",
	"skd_monster",
	"skd_monster_fx",
	"skd_fish_meat",
	"skd_food_other",
	"skd_boss",
    "skd_boss_shadowmeteor",
	"skd_boss_wave",
	"skd_boss_tentacle",
	-- "skd_boss_spawner",
	"skd_new_item",
	"wave",
	"splash",
	"crab_king_waterspout",
	"carnival_sparkle_fx",
}

Assets = {
    Asset( "IMAGE", "bigportraits/skd.tex" ), 
    Asset( "ATLAS", "bigportraits/skd.xml" ),	
    
	Asset( "IMAGE", "images/map_icons/skd.tex" ),
	Asset( "ATLAS", "images/map_icons/skd.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_skd.tex" ), 
    Asset( "ATLAS", "images/avatars/avatar_skd.xml" ),	
    
	Asset( "IMAGE", "images/avatars/avatar_ghost_skd.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_skd.xml" ),	
    
	Asset( "IMAGE", "images/avatars/self_inspect_skd.tex" ), 
    Asset( "ATLAS", "images/avatars/self_inspect_skd.xml" ),     
    
    Asset( "IMAGE", "images/saveslot_portraits/skd.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/skd.xml" ),
    
    Asset( "IMAGE", "images/selectscreen_portraits/skd.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/skd.xml" ),
    
	Asset( "IMAGE", "images/names_skd.tex" ),  
    Asset( "ATLAS", "images/names_skd.xml" ),    
    
    Asset("ATLAS", "images/inventoryimages/skd_food_other1.xml"),
    Asset("IMAGE", "images/inventoryimages/skd_food_other1.tex"),
    
    Asset("ATLAS", "images/inventoryimages/skd_food_other2.xml"),
    Asset("IMAGE", "images/inventoryimages/skd_food_other2.tex"),
    
    Asset("ATLAS", "images/inventoryimages/skd_fishmeat.xml"),
    Asset("IMAGE", "images/inventoryimages/skd_fishmeat.tex"),
    
    Asset("ATLAS", "images/inventoryimages/skd_fishmeat_cooked.xml"),
    Asset("IMAGE", "images/inventoryimages/skd_fishmeat_cooked.tex"),
    
    Asset("ATLAS", "images/inventoryimages/skd_fishmeat_dried.xml"),
    Asset("IMAGE", "images/inventoryimages/skd_fishmeat_dried.tex"),
}

local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS

TUNING.SKD_HEALTH = GetModConfigData("Skd_Health")
TUNING.SKD_HUNGER = GetModConfigData("Skd_Hunger")
TUNING.SKD_SANITY = GetModConfigData("Skd_Sanity")
TUNING.SKD_COMBAT_MULT = GetModConfigData("Skd_Combat_Mult")

TUNING.SKD_SWORD_USE = GetModConfigData("Skd_Sword_Use")
TUNING.SKD_SPAWN_ITEM_MODE = GetModConfigData("Skd_Spawn_Item_Mode")
TUNING.SKD_MONSTER_ATK = GetModConfigData("Skd_Monster_Atk")

if TUNING.SKD_SPAWN_ITEM_MODE == 2 then
    TUNING.STATT_INV = {"skd_sword", "skd_hat"}
elseif TUNING.SKD_SPAWN_ITEM_MODE == 3 then
    TUNING.STATT_INV = {"skd_sword", "skd_hat", "skd_ycbg"}
elseif TUNING.SKD_SPAWN_ITEM_MODE == 1 then
    TUNING.STATT_INV = {}
end	

--[[TUNING.STARTING_ITEM_IMAGE_OVERRIDE["skd_sword"] = {
	atlas = "images/inventoryimages/skd_sword.xml",
	image = "skd_sword.tex",
}

TUNING.STARTING_ITEM_IMAGE_OVERRIDE["skd_hat"] = {
	atlas = "images/inventoryimages/skd_hat.xml",
	image = "skd_hat.tex",
}

TUNING.STARTING_ITEM_IMAGE_OVERRIDE["skd_ycbg"] = {
	atlas = "images/inventoryimages/skd_ycbg.xml",
	image = "skd_ycbg.tex",
}
]]
STRINGS.CHARACTER_TITLES.skd = "深海猎人"
STRINGS.CHARACTER_NAMES.skd = "斯卡蒂"
STRINGS.CHARACTER_DESCRIPTIONS.skd = "*赏金猎人斯卡蒂，前来吞没你的敌人。\n*从潮湿的地方来，到干燥的你身边。\n*受伤的猎人，也会成为猎物。"
STRINGS.CHARACTER_QUOTES.skd = "\"我习惯了独行。\""

STRINGS.NAMES.SKD = "斯卡蒂"
-- STRINGS.SKIN_NAMES.skd_none = "斯卡蒂"  

STRINGS.CHARACTERS.SKD = require "speech_skadi"

STRINGS.NAMES.SKD_SWORD = "大剑"
STRINGS.RECIPE_DESC.SKD_SWORD = "这把剑的过去可是很恐怖的。"  
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_SWORD = "好重的剑。"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_SWORD = "这把剑的过去可是很恐怖的。" 

STRINGS.NAMES.SKD_HAT = "深海猎人帽"
STRINGS.RECIPE_DESC.SKD_HAT = "既是帽子，也是内心。"  --制作栏介绍
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_HAT = "既是帽子，也是内心。"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_HAT = "啊......帽子！"

STRINGS.NAMES.SKD_YCBG = "涌潮悲歌"
STRINGS.RECIPE_DESC.SKD_YCBG = "鲸鱼的声音。"  --制作栏介绍
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_YCBG = "鲸鱼的声音。"
STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.SKD_YCBG = "完全没法理解这种文字，但她确实是打算教我这首歌的。" 
STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.SKD_YCBG = "瓦尔基里的战歌带有神力。" 
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_YCBG = "纠缠着我的噩梦啊，唱个歌吧。"

STRINGS.NAMES.SKD_MONSTER1 = "壳海狂奔者"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_MONSTER1 = "那是什么，奔跑的骨肉？"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_MONSTER1 = "又脏又蠢，只知道进食。"

STRINGS.NAMES.SKD_MONSTER2 = "钵海收割者"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_MONSTER2 = "不要打醒它。"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_MONSTER2 = "怪物，我是你的天敌。"

STRINGS.NAMES.SKD_MONSTER3 = "囊海爬行者"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_MONSTER3 = "它会刺伤攻击者。"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_MONSTER3 = "怪物，我是你的天敌。"

STRINGS.NAMES.SKD_MONSTER4 = "深溟巢涌者"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_MONSTER4 = "它搅动着溟痕。"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_MONSTER4 = "怪物，我是你的天敌。"

STRINGS.NAMES.SKD_FISHMEAT = "恐鱼肉"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_FISHMEAT = "真麻烦，以前只需要杀完它们就行了。"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_FISHMEAT = "可怕的肉。"

STRINGS.NAMES.SKD_FISHMEAT_COOKED = "烤恐鱼肉"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_FISHMEAT_COOKED = "烤过了应该就行吧。"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_FISHMEAT_COOKED = "我绝不会吃这个。"

STRINGS.NAMES.SKD_FISHMEAT_DRIED = "恐鱼肉干"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_FISHMEAT_DRIED = "很难想象那位船长吃了这种东西60年。"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_FISHMEAT_DRIED = "这可不是我该吃的。"

STRINGS.NAMES.SKD_FOOD_OTHER1 = "未尽的生命"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_FOOD_OTHER1 = "它还活着，真恶心。"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_FOOD_OTHER1 = "当心，不要戳破它！"

STRINGS.NAMES.SKD_FOOD_OTHER2 = "光明之躯"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_FOOD_OTHER2 = "只剩下发光的壳了。"  
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_FOOD_OTHER2 = "在发光。"

STRINGS.NAMES.SKD_BOSS = "盐风主教昆图斯"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_BOSS = "你不配, 砍死你就完事了。"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_BOSS = "哇！ 好大的双子向日葵。"

STRINGS.NAMES.SKD_NEW_ITEM1 = "潮湿的剑袋"
STRINGS.RECIPE_DESC.SKD_NEW_ITEM1 = "是什么令深海猎人相聚……"  --制作栏介绍
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_NEW_ITEM1 = "潮湿的剑袋。"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_NEW_ITEM1 = "是的，我会继续捕猎。"

STRINGS.NAMES.SKD_NEW_ITEM2 = "往日残梦"
STRINGS.RECIPE_DESC.SKD_NEW_ITEM2 = "斯卡蒂做了一个梦。梦中夜空浩瀚，点点繁星。"  --制作栏介绍
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SKD_NEW_ITEM2 = "过是个萨克斯盒。"
STRINGS.CHARACTERS.SKD.DESCRIBE.SKD_NEW_ITEM2 = "Ishar-mla，那里......会不会也是一个梦呢？"

AddIngredientValues({"skd_fishmeat"}, {meat=1, monster=2}, true, true)
AddIngredientValues({"skd_fishmeat_cooked"}, {meat=1, monster=2}, true, true)
AddIngredientValues({"skd_fishmeat_dried"}, {meat=1, monster=2}, true, true)

RECIPETABS['skd'] = {str = "skd", sort= 998, icon = "avatar_skd.tex", icon_atlas = "images/avatars/avatar_skd.xml"}

local skd_sword = Recipe("skd_sword", {Ingredient("skd_fishmeat", 2,  "images/inventoryimages/skd_fishmeat.xml"), Ingredient("goldnugget", 40), Ingredient("skd_fishmeat_cooked", 4, "images/inventoryimages/skd_fishmeat_cooked.xml")},RECIPETABS.skd, TECH.NONE)
skd_sword.atlas = "images/inventoryimages/skd_sword.xml"
skd_sword.sortkey = 1

local skd_hat = Recipe("skd_hat", {Ingredient("silk", 12), Ingredient("skd_fishmeat_dried", 3, "images/inventoryimages/skd_fishmeat_dried.xml"), Ingredient("sewing_kit", 1)},RECIPETABS.skd, TECH.NONE)
skd_hat.atlas = "images/inventoryimages/skd_hat.xml"
skd_hat.sortkey = 2

local skd_ycbg = Recipe("skd_ycbg", {Ingredient("papyrus", 1), Ingredient("featherpencil", 1), Ingredient("skd_food_other1", 1, "images/inventoryimages/skd_food_other1.xml")},RECIPETABS.skd, TECH.NONE)
skd_ycbg.atlas = "images/inventoryimages/skd_ycbg.xml"
skd_ycbg.sortkey = 3

local skd_new_item1 = Recipe("skd_new_item1", {Ingredient("skd_food_other1", 1, "images/inventoryimages/skd_food_other1.xml"), Ingredient("skd_fishmeat_cooked", 2, "images/inventoryimages/skd_fishmeat_cooked.xml"), Ingredient("boards", 2)},RECIPETABS.skd, TECH.NONE)
skd_new_item1.atlas = "images/inventoryimages/skd_new_item1.xml"
skd_new_item1.sortkey = 4

local skd_new_item2 = Recipe("skd_new_item2", {Ingredient("skd_food_other2", 1, "images/inventoryimages/skd_food_other2.xml"), Ingredient("steelwool", 2), Ingredient("skd_fishmeat", 2, "images/inventoryimages/skd_fishmeat.xml")},RECIPETABS.skd, TECH.NONE)
skd_new_item2.atlas = "images/inventoryimages/skd_new_item2.xml"
skd_new_item2.sortkey = 5

AddMinimapAtlas("images/map_icons/skd.xml")  
AddMinimapAtlas("images/map_icons/skd_boss.xml")  

AddModCharacter("skd", "FEMALE") 
table.insert(GLOBAL.CHARACTER_GENDERS.MALE, "skd")

AddPrefabPostInit("minotaur", function(inst)
    local skd_boss = SpawnPrefab("skd_boss")
    inst:DoTaskInTime(0, function()
        skd_boss.Transform:SetPosition(Vector3(inst.Transform:GetWorldPosition()):Get())
    end)    
    inst:DoTaskInTime(0.5, function() 
	    inst:Remove()
    end)
end)

modimport("scripts/skd_Hook.lua")
modimport("scripts/skd_sg.lua")
modimport("scripts/skd_skill.lua")
