require "behaviours/wander"
require "behaviours/doaction"
require "behaviours/chaseandattack"
require "behaviours/standstill"
local BrainCommon = require("brains/braincommon")

local STOP_RUN_DIST = 10
local SEE_PLAYER_DIST = 5
local MAX_WANDER_DIST = 20
local SEE_TARGET_DIST = 6

local MAX_CHASE_DIST = 7
local MAX_CHASE_TIME = 8

local function GoHomeAction(inst)
    if inst.components.homeseeker and
       inst.components.homeseeker.home and
       inst.components.homeseeker.home:IsValid() then
        return BufferedAction(inst, inst.components.homeseeker.home, ACTIONS.GOHOME)
    end
end

local function ShouldGoHome(inst)
    return not GetWorld().state.isday or GetWorld().state.iswinter
end

local function GetWanderPos(inst)
    return Point(inst.Transform:GetWorldPosition())
end

local Skd_Boss_Brain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

function Skd_Boss_Brain:OnStart()
    local root = PriorityNode(
    {
		BrainCommon.PanicTrigger(self.inst),
        ChaseAndAttack(self.inst, MAX_CHASE_TIME)
    }, .25)
    self.bt = BT(self.inst, root)
end

return Skd_Boss_Brain
