local MakePlayerCharacter = require "prefabs/player_common"

local assets = {
    Asset( "ANIM", "anim/skd.zip" ),      
    Asset( "ANIM", "anim/skadi_attack.zip" ), 
    Asset( "ANIM", "anim/player_attack_prop.zip" ),
}
local prefabs = {}

-- 初始物品
local start_inv = TUNING.STATT_INV


--[[local function onbecamehuman(inst)
	inst.components.locomotor:SetExternalSpeedMultiplier(inst, "skd_speed_mod", 1)
end

local function onbecameghost(inst)
   inst.components.locomotor:RemoveExternalSpeedMultiplier(inst, "skd_speed_mod")
end]]

--[[local function OnSave(inst, data)
    data.boss_health = inst.boss_health
end]]

--[[local function onload(inst, data)
    if data ~= nil then
        if data.boss_health ~= nil then
            inst.boss_health = data.boss_health
        end
    end

    inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)
    inst:ListenForEvent("ms_becameghost", onbecameghost)

    if inst:HasTag("playerghost") then
        onbecameghost(inst)
    else
        onbecamehuman(inst)
    end
end]]

local function OnNewSpawn(inst)
    if TUNING.SKD_SPAWN_ITEM_MODE == 2 or TUNING.SKD_SPAWN_ITEM_MODE == 3 then
    local sword = SpawnPrefab("skd_sword")
    inst.components.inventory:Equip(sword)

    local hat = SpawnPrefab("skd_hat")
    inst.components.inventory:GiveItem(hat)
    end

    if TUNING.SKD_SPAWN_ITEM_MODE == 3 then 
    local book = SpawnPrefab("skd_ycbg")
    inst.components.inventory:GiveItem(book)
    end          
end

local function Skill1(inst, val)
    local percent = inst.components.health:GetPercent() or 1
    if val then
        if inst.ycbg_fx == nil or (inst.ycbg_fx and not inst.ycbg_fx:IsValid()) then
            inst.ycbg_fx = SpawnPrefab("skd_ycbg_fx")
            inst.ycbg_fx.entity:SetParent(inst.entity)
        end

        inst.components.combat:AddDamageModifier("skd", TUNING.SKD_COMBAT_MULT + ((TUNING.SKD_COMBAT_MULT + 1 ) * 1.3 ))
        inst.components.health:SetMaxHealth(TUNING.SKD_HEALTH + (TUNING.SKD_HEALTH * 1.3))
    else
        if inst.ycbg_fx and inst.ycbg_fx:IsValid() then
            inst.ycbg_fx:Remove()
            inst.ycbg_fx = nil
        end

        inst.components.combat:AddDamageModifier("skd", TUNING.SKD_COMBAT_MULT)
        inst.components.health:SetMaxHealth(TUNING.SKD_HEALTH)        
    end

    inst.components.health:SetPercent(percent)
end

local function OnHealthDelta(inst, data)
  if TUNING.SKD_MONSTER_ATK ~= true then return end
  if inst.components.health:GetPercent() <= 0.75 then
    inst.components.talker:Say("我流血了, 它们会来找我。")
    if GetWorld() and not GetWorld():HasTag("spawn_skd_monster") then
      GetWorld():AddTag("spawn_skd_monster")               
    end
  end
end

local fn = function(inst)
    inst.monster_health = 0
    inst.boss_health = 0

	inst.soundsname = "winona"
	
	inst:AddTag("skd")
    inst:AddTag("reader")
    inst:AddTag("stronggrip")
    inst:AddTag("bookreader")
	inst.MiniMapEntity:SetIcon( "skd.tex" )

	inst.components.health:SetMaxHealth(TUNING.SKD_HEALTH)
	inst.components.hunger:SetMax(TUNING.SKD_HUNGER)
	inst.components.sanity:SetMax(TUNING.SKD_SANITY)
    inst.components.sanity.no_moisture_penalty = true
	
    inst.components.combat:AddDamageModifier("skd", TUNING.SKD_COMBAT_MULT)
	
	inst.components.hunger.hungerrate = 1 * TUNING.WILSON_HUNGER_RATE

    inst:AddComponent("reader")
	
    inst:ListenForEvent("timerdone", function(inst, data)
        if data.name == "Skd_Skill1" then
            Skill1(inst, false)
            inst.components.talker:Say("技能效果结束！！")

        elseif data.name == "Skd_Skill1_Cd" then
        	inst:RemoveTag("skill1_cd")
            inst.components.talker:Say("技能CD结束！！")             
        end 
    end) 

    inst:DoTaskInTime(0, function(inst)
        local Skill_Buff = inst.components.timer ~= nil and (inst.components.timer:GetTimeLeft("Skd_Skill1") or 0) or nil        
        local Skill_Cd = inst.components.timer ~= nil and (inst.components.timer:GetTimeLeft("Skd_Skill1_Cd") or 0) or nil
        if Skill_Buff ~= nil and Skill_Buff > 0 then
            Skill1(inst, true)
        end

        if Skill_Cd ~= nil and Skill_Cd > 0 then
            inst:AddTag("skill1_cd")
        end
    end)

    inst:ListenForEvent("attacked", OnHealthDelta)

    inst.Skill1 = Skill1

	--inst.OnLoad = onload
    --inst.OnNewSpawn = OnNewSpawn
end

return MakePlayerCharacter("skd", prefabs, assets, fn, start_inv)
