local function MakeFishMeat(name, bank, build, anim, health, hunger, sanity, perishtime, monster_num)

local assets =
{
    Asset("ANIM", "anim/skd_fishmeat.zip"),
    Asset("ANIM", "anim/skd_fishmeat_dried_anim1.zip"),
    Asset("ANIM", "anim/skd_fishmeat_dried_anim2.zip"),
    Asset("ATLAS", "images/inventoryimages/"..name..".xml")
}

local function AddDeBuff(inst)
    local time = 0
    if inst.skd_fishmeat_task then
        inst.skd_fishmeat_task:Cancel()
        inst.skd_fishmeat_task = nil
    end

    inst.skd_fishmeat_task = inst:DoPeriodicTask(1, function()      
        inst.components.health:DoDelta(-2)

        time = time + 1
        if time >= 30 or inst.components.health:IsDead() then
        if inst.skd_fishmeat_task then
            inst.skd_fishmeat_task:Cancel()
            inst.skd_fishmeat_task = nil
        end                
        end    
    end)     
end    


local function OnEat(inst, eater)
    if name == "skd_fishmeat" and eater and eater.components.health then
        AddDeBuff(eater)
    end 

    if eater and eater.components.monster_num then
        eater.components.monster_num:DoDelta(monster_num)  
    end   
end    

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddDynamicShadow()
    -- inst.entity:AddNetwork()

    inst:AddTag("meat")
    inst:AddTag("monstermeat")

    if name == "skd_fishmeat" then
        inst:AddTag("cookable")
    end

    inst.AnimState:SetBank(bank)
    inst.AnimState:SetBuild(build)
    inst.AnimState:PlayAnimation(anim)

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "small")

    -- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- return inst
    -- end

    inst.monster_num = monster_num

    inst:AddComponent("tradable")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = name
    inst.components.inventoryitem.atlasname = "images/inventoryimages/"..name..".xml"

    inst:AddComponent("edible")
    inst.components.edible.ismeat = true
    -- inst.components.edible.foodtype = FOODTYPE.MEAT
    -- inst.components.edible.secondaryfoodtype = FOODTYPE.MONSTER
    inst.components.edible.healthvalue = health
    inst.components.edible.hungervalue = hunger
    inst.components.edible.sanityvalue = sanity
    inst.components.edible:SetOnEatenFn(OnEat) 

    inst:AddComponent("perishable")
    inst.components.perishable:SetPerishTime(perishtime)
    inst.components.perishable:StartPerishing()
    inst.components.perishable.onperishreplacement = "spoiled_food"

    inst:AddComponent("stackable")
    inst:AddComponent("selfstacker")

    if name == "skd_fishmeat" then
        inst:AddComponent("cookable")
        inst.components.cookable.product = "skd_fishmeat_cooked"

        inst:AddComponent("dryable")
        inst.components.dryable:SetProduct("skd_fishmeat_dried")
        inst.components.dryable:SetDryTime(TUNING.DRY_FAST)
--        inst.components.dryable:SetBuildFile("skd_fishmeat_dried_anim1")
--        inst.components.dryable:SetDriedBuildFile("skd_fishmeat_dried_anim2")        
    end

    return inst
end

return Prefab(name, fn, assets)
end   

return MakeFishMeat("skd_fishmeat", "skd_fishmeat", "skd_fishmeat", "idle", 20, 25, -40, 480*20, 2),
       MakeFishMeat("skd_fishmeat_cooked", "skd_fishmeat", "skd_fishmeat", "cooked", 30, 25, -10, 480*10, 1),
       MakeFishMeat("skd_fishmeat_dried", "skd_fishmeat_dried", "skd_fishmeat", "idle", 30, 25, -10, 480*40, 1)