local function MakeFood(name, health, hunger, sanity, perishtime)

local assets =
{
    Asset("ANIM", "anim/"..name..".zip"),
    Asset("ATLAS", "images/inventoryimages/"..name..".xml")
}

local function SpawnMonster(inst)
    local mat = math.random()
    local prefab = (mat > 0.15 and "skd_monster1") or (mat <= 0.15 and mat > 0.1 and "skd_monster2")
    or (mat <= 0.1 and mat > 0.05 and "skd_monster3") or "skd_monster4"

    local monster = SpawnPrefab(prefab)
    if monster then
        monster.components.combat:SetTarget(inst)
        monster.Transform:SetPosition(inst:GetPosition():Get())
    end
end

local function AddBuff(inst)
    if inst.skd_food_other2_task then
        inst.skd_food_other2_task:Cancel()
        inst.skd_food_other2_task = nil
    end 

    inst.Light:Enable(true)
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

    inst.skd_food_other2_task = inst:DoTaskInTime(30, function(inst)
        inst.Light:Enable(false)
        inst.AnimState:ClearBloomEffectHandle()

        if inst.skd_food_other2_task then
            inst.skd_food_other2_task:Cancel()
            inst.skd_food_other2_task = nil
        end         
    end)    
end

local function OnEat(inst, eater)
    if name == "skd_food_other1" then
        SpawnMonster(eater)
    end 

    if name == "skd_food_other2" and eater and eater.components.monster_num then
        AddBuff(eater)
        eater.components.monster_num:DoDelta(2)  
    end   
end 

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddDynamicShadow()
    -- inst.entity:AddNetwork()

    inst:AddTag("meat")

    inst.AnimState:SetBank(name)
    inst.AnimState:SetBuild(name)
    inst.AnimState:PlayAnimation("idle")

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "small")

    -- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- return inst
    -- end

    inst:AddComponent("inspectable")

    inst:AddComponent("stackable")

    inst:AddComponent("tradable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = name
    inst.components.inventoryitem.atlasname = "images/inventoryimages/"..name..".xml"

    inst:AddComponent("edible")
    inst.components.edible.ismeat = true
    -- inst.components.edible.foodtype = FOODTYPE.MEAT
    inst.components.edible.healthvalue = health
    inst.components.edible.hungervalue = hunger
    inst.components.edible.sanityvalue = sanity
    inst.components.edible:SetOnEatenFn(OnEat)

    inst:AddComponent("perishable")
    inst.components.perishable:SetPerishTime(perishtime)
    inst.components.perishable:StartPerishing()
    inst.components.perishable.onperishreplacement = "spoiled_food"

    return inst
end

return Prefab(name, fn, assets)
end   

return MakeFood("skd_food_other1", -300, 150, -100, 480*10),
       MakeFood("skd_food_other2", 10, 12.5, -30, 480*20)