local assets =
{
    Asset("ANIM", "anim/skd_hat.zip"),
    Asset("ATLAS", "images/inventoryimages/skd_hat.xml")
}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_hat", "skd_hat", "swap_hat")
    owner.AnimState:Show("HAT")
    owner.AnimState:Show("HAIR_HAT")
    owner.AnimState:Hide("HAIR_NOHAT")

    if owner:HasTag("player") then
        owner.AnimState:Hide("HEAD")
        owner.AnimState:Show("HEAD_HAT")
    end

    if inst.components.fueled ~= nil then
        inst.components.fueled:StartConsuming()
    end        
end 

local function onunequip(inst, owner)
    owner.AnimState:ClearOverrideSymbol("swap_hat")
    owner.AnimState:Hide("HAT")
    owner.AnimState:Hide("HAIR_HAT")
    owner.AnimState:Show("HAIR_NOHAT")
    owner.AnimState:Show("HAIR")

    if owner:HasTag("player") then
        owner.AnimState:Show("HEAD")
        owner.AnimState:Hide("HEAD_HAT")
    end

    if inst.components.fueled ~= nil then
        inst.components.fueled:StopConsuming()
    end          
end    

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    -- inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst:AddTag("hat")
    inst:AddTag("waterproofer")

    inst.AnimState:SetBank("skd_hat")
    inst.AnimState:SetBuild("skd_hat")
    inst.AnimState:PlayAnimation("anim")

    -- MakeInventoryFloatable(inst, "small")
    MakeInventoryFloatable(inst,"anim","anim")

    -- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- return inst
    -- end

    inst:AddComponent("tradable")    
    inst:AddComponent("inspectable")    

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "skd_hat"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/skd_hat.xml"

    inst:AddComponent("waterproofer")
    inst.components.waterproofer:SetEffectiveness(0.8)   

    inst:AddComponent("fueled")
    -- inst.components.fueled.fueltype = FUELTYPE.USAGE
    inst.components.fueled:InitializeFuelLevel(480*12)
    inst.components.fueled:SetDepletedFn(inst.Remove)

    inst:AddComponent("equippable")  
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
    inst.components.equippable.dapperness = 6.6/60
    inst.components.equippable.restrictedtag = "skd" 

    -- MakeHauntableLaunch(inst)

    return inst
end

return Prefab("skd_hat", fn, assets)