local assets =
{
	Asset("ANIM", "anim/skd_new_item1.zip"),
	Asset("ANIM", "anim/skd_new_item2.zip"),
    Asset("ANIM", "anim/ui_chest_3x1.zip"),

    Asset("ATLAS", "images/inventoryimages/skd_new_item1.xml"),
    Asset("ATLAS", "images/inventoryimages/skd_new_item2.xml")
}

local slotpos = {}
local function itemtest(inst, item, slot)
    if item.prefab == "skd_hat" or item.prefab == "skd_sword"  or item.prefab == "skd_ycbg" 
       then
	   return true
    end
    return false
end

for x = 0, 2 do
	table.insert(slotpos, Vector3(-x*80+80,0 ,0))
end

local function ondeploy(inst, pt) 
end

local function skd_findItem(item)
    return item:HasTag("skd_sword")
end

local function onopen(inst) 
	inst.SoundEmitter:PlaySound("dontstarve/common/craftable/icebox_open")
end 

local function onclose(inst) 
	inst.SoundEmitter:PlaySound("dontstarve/common/craftable/icebox_close")
end

local function doresurrect(inst, dude)
	inst:AddTag("busy")
    dude.Transform:SetPosition(inst.Transform:GetWorldPosition())
    dude:Hide()
    TheCamera:SetDistance(12)
	dude.components.hunger:Pause()
	
    scheduler:ExecuteInTime(2, function()
        dude:Show()

		inst.SoundEmitter:PlaySound("dontstarve/common/resurrectionstone_break")
       
        if dude.components.hunger then
            dude.components.hunger:SetPercent(1)
        end

        if dude.components.health then
            dude.components.health:SetPercent(1)
        end
        
        if dude.components.sanity then
			dude.components.sanity:SetPercent(1)
        end

        if dude.components.moisture then
        	dude.components.moisture.moisture = 0
        end

        if dude.components.temperature then
        	dude.components.temperature:SetTemperature(20)
        end
        
        dude.components.hunger:Resume()
        
        dude.sg:GoToState("wakeup")
        
        
        dude:DoTaskInTime(3, function(inst) 
		            if dude.HUD then
		                dude.HUD:Show()
		            end
		            TheCamera:SetDefault()
		            inst:RemoveTag("busy")
        end)
        
    end)
end

local function fn1()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    -- inst.entity:AddNetwork()

    inst.AnimState:SetBank("skd_new_item1")
    inst.AnimState:SetBuild("skd_new_item1")
    inst.AnimState:PlayAnimation("empty")

    inst:AddTag("skd_new_item1")

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "small")

    -- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- inst.OnEntityReplicated = function(inst) if inst.replica.container then inst.replica.container:WidgetSetup("skd_new_item1") end end
        -- return inst
    -- end

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "skd_new_item1"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/skd_new_item1.xml"
    inst.components.inventoryitem.keepondeath = true

    --inst:AddComponent("container")
    --inst.components.container:WidgetSetup("skd_new_item1")
    
    inst:AddComponent("container")
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_chest_3x1"
    inst.components.container.widgetanimbuild = "ui_chest_3x1"
    inst.components.container.widgetpos = Vector3(-80,100,0)
    inst.components.container.side_align_tip = 160
    inst.components.container.itemtestfn = itemtest

    inst:DoPeriodicTask(0.1, function(inst)
        if inst.components.container:FindItem(skd_findItem) then
            inst.AnimState:PlayAnimation("idle")            
        else    
            inst.AnimState:PlayAnimation("empty")
        end    
    end) 

    -- MakeHauntableLaunch(inst)
    
    inst:AddComponent("resurrector")
   inst.components.resurrector.active = true
   inst.components.resurrector.doresurrect = doresurrect
 
    return inst
end

local function fn2()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    -- inst.entity:AddNetwork()

    inst.AnimState:SetBank("skd_new_item2")
    inst.AnimState:SetBuild("skd_new_item2")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("skd_new_item2")

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "small")

    -- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- inst.OnEntityReplicated = function(inst) if inst.replica.container then inst.replica.container:WidgetSetup("skd_new_item2") end end
        -- return inst
    -- end

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "skd_new_item2"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/skd_new_item2.xml"
    inst.components.inventoryitem.keepondeath = true

    --inst:AddComponent("container")
    --inst.components.container:WidgetSetup("skd_new_item2")
    
    inst:AddComponent("container")
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_chest_3x1"
    inst.components.container.widgetanimbuild = "ui_chest_3x1"
    inst.components.container.widgetpos = Vector3(-80,100,0)
    inst.components.container.side_align_tip = 160
    inst.components.container.itemtestfn = itemtest

    -- MakeHauntableLaunch(inst)

    return inst
end

local function fx()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    -- inst.entity:AddNetwork()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst:AddTag("FX")
    inst.entity:SetCanSleep(false)

    inst.AnimState:SetBank("pillowfight_confetti")
    inst.AnimState:SetBuild("pillowfight_confetti")
    inst.AnimState:PlayAnimation("out", false) 
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

    inst.AnimState:SetAddColour(0, 1, 1, 0) --c_spawn"skd_new_item1_fx".AnimState:SetAddColour(0, 1, 1, 0)
    --inst.AnimState:SetMultColour(1, 1, 1, 0.5)
    --inst.Transform:SetScale(0.7, 0.7, 0.7)
    --inst.AnimState:SetDeltaTimeMultiplier(1.3)

    -- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- return inst
    -- end

    inst.persists = false
    inst:ListenForEvent("animover", inst.Remove)

    inst:DoTaskInTime(0, function(inst)
       inst.SoundEmitter:PlaySound("summerevent/cannon/fire1")
    end)

    return inst
end

return Prefab("skd_new_item1", fn1, assets),
       Prefab("skd_new_item2", fn2, assets),
       Prefab("skd_new_item1_fx", fx, assets)