local assets =
{
	Asset("ANIM", "anim/skd_sword.zip"),
    Asset("ANIM", "anim/swap_skd_sword.zip"),
    Asset("ATLAS", "images/inventoryimages/skd_sword.xml")
}

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_skd_sword", "swap_sword")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    -- inst.entity:AddNetwork()

    inst.AnimState:SetBank("skd_sword")
    inst.AnimState:SetBuild("skd_sword")
    inst.AnimState:PlayAnimation("idle", true)  --c_findnext("skd_sword")

    inst:AddTag("sharp")
    inst:AddTag("pointy")
    inst:AddTag("weapon")

    inst:AddTag("skd_sword")

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "small")

    -- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- return inst
    -- end

    inst:AddComponent("inspectable")

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(85)

    if TUNING.SKD_SWORD_USE then
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(400)
    inst.components.finiteuses:SetUses(400)
    inst.components.finiteuses:SetOnFinished(inst.Remove)
    end

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "skd_sword"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/skd_sword.xml"
    inst.components.inventoryitem.keepondeath = true

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
    inst.components.equippable.walkspeedmult = 0.3
    inst.components.equippable.restrictedtag = "skd" 

    -- MakeHauntableLaunch(inst)

    return inst
end

return Prefab("skd_sword", fn, assets)