local assets =
{
	Asset("ANIM", "anim/skd_ycbg.zip"),
    Asset("ATLAS", "images/inventoryimages/skd_ycbg.xml")
}

local function SpawnFx(inst, pt)
    local fx = SpawnPrefab("carnival_sparkle_fx")
    fx.entity:SetParent(inst.entity)  
    
    local angle = 0
    local radius = 5
    local number = 4
    for i=1, number do        
        local offset = Vector3(radius * math.cos( angle ), 0, -radius * math.sin( angle ))
        local newpt = pt + offset
        local x, y, z = newpt:Get()

        local rock = SpawnPrefab("crab_king_waterspout")
        rock.Transform:SetPosition(newpt.x, newpt.y, newpt.z)

        angle = angle + (PI*2/number)
    end
end

local function SKD_Skill1(inst)
    if not inst:HasTag("skill1_cd") then
        inst:AddComponent("timer")
        inst:AddTag("skill1_cd")
        inst.components.hunger:DoDelta(-100)

        local pt = Vector3(inst.Transform:GetWorldPosition())
        SpawnFx(inst, pt)

        inst.spawnfx_task = inst:DoTaskInTime(0.6, function(inst)
            inst:Skill1(true)

            if inst.spawnfx_task then
                inst.spawnfx_task:Cancel()
                inst.spawnfx_task = nil
            end    
        end)    

        inst.components.timer:StartTimer("Skd_Skill1", 50)

        if inst.components.inventory:FindItem(function(item) return item.prefab == "skd_new_item2" end) then
        	--print("80")
            inst.components.timer:StartTimer("Skd_Skill1_Cd", 80)
        else
        	--print("140")
            inst.components.timer:StartTimer("Skd_Skill1_Cd", 140)
        end                
    end        
end

local function OnRead(inst, reader)
    if reader and reader:HasTag("skd") then
    if reader.components.hunger.current <= 100 then
        reader.components.talker:Say("体力不足。。") 

    elseif reader:HasTag("skill1_cd") then
        reader.components.talker:Say("技能冷却中") 

    else    
        SKD_Skill1(reader)
    end
    end    
    return true
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    -- inst.entity:AddNetwork()

    inst.AnimState:SetBank("skd_ycbg")
    inst.AnimState:SetBuild("skd_ycbg")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("skd_ycbg")


    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "small")

    inst.Transform:SetScale(1.4, 1.4, 1.4)

    -- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- return inst
    -- end

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "skd_ycbg"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/skd_ycbg.xml"
    inst.components.inventoryitem.keepondeath = true

    inst:AddComponent("book")
    inst.components.book.onread = OnRead

    -- MakeHauntableLaunch(inst)

    return inst
end

local fxassets =
{
    Asset("ANIM", "anim/lavaarena_battlestandard.zip")
}

local function fx()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    -- inst.entity:AddNetwork()
    inst.entity:AddAnimState()
    inst:AddTag("FX")
    inst.entity:SetCanSleep(false)

    inst.AnimState:SetBank("lavaarena_battlestandard")
    inst.AnimState:SetBuild("lavaarena_battlestandard")
    inst.AnimState:PlayAnimation("attack_fx3", true) 
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

    inst.AnimState:SetFinalOffset(-1)
    inst.AnimState:SetOrientation( ANIM_ORIENTATION.OnGround )
    inst.AnimState:SetLayer( LAYER_BACKGROUND )
    inst.AnimState:SetSortOrder( 3 )
    --140/255, 239/255, 50/255, 1
    inst.AnimState:SetMultColour(50/255, 239/255, 255/255, 1)  

    -- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- return inst
    -- end

    inst.persists = false

    return inst
end

return Prefab("skd_ycbg", fn, assets),
       Prefab("skd_ycbg_fx", fx, fxassets)