GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})

local function SpawnFx(inst, pt)
    local angle = 0
    local radius = 5
    local number = 4
    for i=1, number do        
        local offset = Vector3(radius * math.cos( angle ), 0, -radius * math.sin( angle ))
        local newpt = pt + offset
        local x, y, z = newpt:Get()

        local rock = SpawnPrefab("crab_king_waterspout")
        rock.Transform:SetPosition(newpt.x, newpt.y, newpt.z)

        angle = angle + (PI*2/number)
    end
end

local function SKD_Skill1(inst)
    if inst:HasTag("skd") then 
        if inst.sg and not inst:HasTag("skill1_cd") then
            inst:AddTag("skill1_cd")
            inst:Skill1(true)

            inst.components.hunger:DoDelta(-100)

            inst.spawnfx_task = inst:DoTaskInTime(0.6, function(inst)
                local pt = Vector3(inst.Transform:GetWorldPosition())
                SpawnFx(inst, pt)

                if inst.spawnfx_task then
                    inst.spawnfx_task:Cancel()
                    inst.spawnfx_task = nil
                end    
            end)    

            inst.sg:GoToState("play_strum")
            inst.components.timer:StartTimer("Skd_Skill1", 100) 
            inst.components.timer:StartTimer("Skd_Skill1_Cd", 180)                
        end        
    end
end

-- AddModRPCHandler("SKD_Skill1", "SKD_Skill1", SKD_Skill1)
--[[
TheInput:AddKeyDownHandler(KEY_R, function()                            
    local player = ThePlayer
    local screen = GLOBAL.TheFrontEnd:GetActiveScreen()
    local IsHUDActive = screen and screen.name == "HUD"
 
    if player and player:HasTag("skd") and not player:HasTag("skill1_cd")
    and player.replica.hunger and player.replica.hunger:GetCurrent() >= 100   
    and not player:HasTag("playerghost") and IsHUDActive then
        if player.sg then
            player.sg:GoToState("play_strum")
        end    
        SendModRPCToServer(MOD_RPC["SKD_Skill1"]["SKD_Skill1"]) 
    end 
end)
]]   

local function nohitsg(sg)
    local old_onattacked = sg.events['attacked'].fn
    sg.events['attacked'] = EventHandler('attacked', function(inst, data,...)
        if data and data.attacker and data.attacker.prefab == "skd_monster4" then
            return
        end
  
        old_onattacked(inst,data,...)
    end)
end

AddStategraphPostInit("wilson", nohitsg)
