require("stategraphs/commonstates")

local events=
{
    EventHandler("death", function(inst) inst.sg:GoToState("death") end),
    EventHandler("doattack", function(inst) 
    if inst.prefab ~= "skd_monster3" and inst.prefab ~= "skd_monster4" and not inst.components.health:IsDead() and not inst.sg:HasStateTag("busy") then
        inst.sg:GoToState("attack")
    end 
    end),

    CommonHandlers.OnSleep(),
    CommonHandlers.OnFreeze(),

    EventHandler("locomote",
        function(inst)
            if not inst.sg:HasStateTag("idle") then return end
            inst.sg:GoToState("run")
        end),
--[[
    EventHandler("attacked", function(inst)
        if not inst.components.health:IsDead() and not inst.sg:HasStateTag("busy") and not inst.sg:HasStateTag("attack") and not CommonHandlers.HitRecoveryDelay(inst) then
            inst.sg:GoToState("hit")
        end
    end),
]]
}

local FROG_TAGS = {"frog"}
local states=
{

    State{
        name = "idle",
        tags = {"idle", "canrotate"},

        onenter = function(inst, pushanim)
            inst.Physics:Stop() 
            if inst.prefab == "skd_monster2" and inst.components.health:GetPercent() >= 1 then
            inst.AnimState:PlayAnimation("frozen", true)  
            else    
            inst.AnimState:PlayAnimation("idle", true)
            end  
        end,
    },

    State{
        name = "run",
        tags = {"moving", "running", "canrotate"},

        onenter = function(inst)
            inst.components.locomotor:RunForward()

            if inst.prefab == "skd_monster2" and inst.components.health:GetPercent() >= 1 then
            inst.AnimState:PlayAnimation("idle", true)  
            else    
            inst.AnimState:PlayAnimation("move", true)
            end

            inst.sg:SetTimeout(1)
        end,

        ontimeout = function(inst)
            inst.sg:GoToState("run")
        end,
    },

    State{
        name = "attack",
        tags = {"attack"},

        onenter = function(inst, cb)
            inst.Physics:Stop()
            inst.components.combat:StartAttack()
            inst.AnimState:PlayAnimation("attack")
        end,

        timeline=
        {
            TimeEvent(16*FRAMES, function(inst) inst.components.combat:DoAttack() end),
        },

        events=
        {
            EventHandler("animqueueover", function(inst) inst.sg:GoToState("idle") end),
        },
    },

    State{
        name = "hit",
        tags = {"busy"},

        onenter = function(inst)
            inst.AnimState:PlayAnimation("sleep_pst")
            inst.Physics:Stop()
        end,

        events =
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),
        },
    },

    State{
        name = "death",
        tags = {"busy"},

        onenter = function(inst)
            inst.AnimState:PlayAnimation("death")
            inst.Physics:Stop()
            RemovePhysicsColliders(inst)
            inst.components.lootdropper:DropLoot(inst:GetPosition())
        end,
    },
}

CommonStates.AddFrozenStates(states)
--CommonStates.AddSinkAndWashAsoreStates(states)

return StateGraph("skd_monster", states, events, "idle")
